// ukazka par operaci ze sync/atomic
package main

import (
	"fmt"
	"sync/atomic"
	"time"
)

var aCounter int32

func incrementAtomics() {
	atomic.AddInt32(&aCounter, 1)
}

func atomicsExample() {
	fmt.Println("\n---ATOMICS---")
	go func() {
		time.Sleep(250 * time.Millisecond)
		atomic.StoreInt32(&aCounter, 10)
		time.Sleep(250 * time.Millisecond)
		fmt.Println(atomic.LoadInt32(&aCounter))
	}()
	count := 100
	for count > 0 {
		go func() {
			time.Sleep(250 * time.Millisecond)
			incrementAtomics()
		}()
		count--
	}
	time.Sleep(2 * time.Second)
}
