// cond, podminena promenna - zakladni ukazka
package main

import (
	"fmt"
	"sync"
	"time"
)

var mu sync.Mutex //potrebujeme vnitnri zamek
var cond = sync.NewCond(&mu)
var ready = false

func waitForReady(id int) {
	cond.L.Lock()
	for !ready {
		fmt.Printf("%d: Waiting\n", id)
		cond.Wait() // atomicky odemkne zamek a ceka (po probuzeni musi ziskat zamek)
	}
	cond.L.Unlock()
	fmt.Printf("%d: Ready\n", id)
}

func condExample() {
	fmt.Println("\n---CONDITIONAL VARIABLE---")
	go waitForReady(1)
	go waitForReady(2)

	time.Sleep(time.Second)
	cond.L.Lock()
	ready = true
	cond.L.Unlock()
	cond.Broadcast() //probudi vsechny cekajici na Wait() (v tomto okamziku nemusi drzet zamek)
	time.Sleep(2 * time.Second)
}
