package main

import (
	"fmt"
	"sync"
	"time"
)

func mapExample() {
	fmt.Println("\n---CONCURRENT MAP---")

	var m sync.Map

	// zapisy
	go func() {
		for i := 0; i < 5; i++ {
			key := fmt.Sprintf("key%d", i)
			m.Store(key, i)
			fmt.Printf("Stored %s: %d\n", key, i)
			time.Sleep(100 * time.Millisecond)
		}
	}()

	// cteni
	go func() {
		for i := 0; i < 5; i++ {
			key := fmt.Sprintf("key%d", i)
			value, ok := m.Load(key)
			if ok {
				fmt.Printf("Loaded %s: %d\n", key, value)
			} else {
				fmt.Printf("%s not found\n", key)
			}
			time.Sleep(150 * time.Millisecond)
		}
	}()

	time.Sleep(1 * time.Second)

	// pruchod mapou
	fmt.Println("All key-value pairs:")
	m.Range(func(key, value interface{}) bool {
		fmt.Printf("%s: %v\n", key, value)
		return true
	})
}
