// jedoduchá ukázka poolu s buffery
package main

import (
	"bytes"
	"fmt"
	"sync"
	"time"
)

var bufferCount int = 0

var pool = sync.Pool{
	New: func() interface{} {
		fmt.Printf("Nový buffer %d\n", bufferCount)
		bufferCount++
		return new(bytes.Buffer)
	},
}

func work(id int) {
	buf := pool.Get().(*bytes.Buffer) //vezmeme si buffer
	buf.WriteString(fmt.Sprintf("%d pracuje", id))
	fmt.Println(buf.String())
	time.Sleep(3 * time.Millisecond)
	buf.Reset()   // vycistime buffer
	pool.Put(buf) // vratime buffer
}

func poolExample() {
	fmt.Println("\n---POOL (BUFFER)---")

	count := 100
	for count > 0 {
		go work(count)
		time.Sleep(time.Millisecond)
		count--
	}
	time.Sleep(5 * time.Second)
}
