// Read-Write-mutex pro ctenare a pisare
package main

import (
	"fmt"
	"sync"
	"time"
)

var rwMutex sync.RWMutex
var data = make(map[string]string) //slovnik string -> string

func readData(key string) string {
	rwMutex.RLock()
	defer rwMutex.RUnlock()
	fmt.Printf("Reading key %s value %s\n", key, data[key])
	return data[key]
}

func writeData(key, value string) {
	rwMutex.Lock()
	defer rwMutex.Unlock()
	fmt.Printf("Writing key %s value %s\n", key, value)
	data[key] = value

}

func rwMutexExample() {
	fmt.Println("\n---RWMUTEX---")

	// pisar
	go func() {
		keys := []string{"name", "age", "country"}
		values := [][]string{{"Alice", "30", "USA"}, {"Bob", "40", "Peru"}, {"Vlad", "unknown", "Romania"}}

		for k := 0; k < 5; k++ {
			for j := 0; j < 3; j++ {
				for i := 0; i < len(keys); i++ {
					writeData(keys[i], values[j][i])
					fmt.Printf("Written %s: %s\n", keys[i], values[j][i])
					time.Sleep(50 * time.Millisecond)
				}
			}
		}
	}()

	// ctenari
	for i := 0; i < 5; i++ {
		go func(id int) {
			for j := 0; j < 20; j++ {
				fmt.Printf("Goroutine %d reading name %s, age %s, country %s\n", id, readData("name"), readData("age"), readData("country"))
				time.Sleep(150 * time.Millisecond)
			}
		}(i + 1)
	}

	time.Sleep(4 * time.Second)
}
