// Pouziti WaitGroup pro jednoduche cekani na ukonceni
package main

import (
	"fmt"
	"sync"
	"time"
)

var wg sync.WaitGroup

func doWork(id int) {
	defer wg.Done()
	fmt.Printf("%d is working\n", id)
	time.Sleep(time.Second)
	fmt.Printf("%d done\n", id)
}

func waitGroupExample() {
	fmt.Println("\n---WAITGROUP---")

	numJobs := 5
	wg.Add(numJobs)
	for i := 0; i < numJobs; i++ {
		go doWork(i)
	}
	fmt.Println("I am waiting")
	wg.Wait()
	fmt.Println("Done")
}
